//---------------Billiard balls---------------------
//      This program written by Sergey V. Baskov
//      The algorithm of ball's collision developed
//        by program author (Baskov Sergey)
//      e-mail: news4me@mail.ru
//      http://www.baskov.spb.ru
//      Saint-Petersburg,2000(algorithm) - Moscow,2002(program)
//	Freeware
//      NOT FOR COMMERCIAL PURPOSES!
//------------------------------------

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Math, inifiles, mmsystem;

resourcestring
  author = 'Author: Sergey V. Baskov - http://www.baskov.spb.ru - news4me@mail.ru';

const
  w = 600;
  h = 300;

type
  TGameStatus = (gsBegin, gsGame, gsGameOver);
  TPlayer = record
    balls: integer;
  end;
  pLose = ^TLose;
  TLose = object
    x, y: integer;
    ballsInside: integer;
    R: integer;
    procedure Draw;
  end;
  pBall = ^TBall;
  TBall = object
    x, y: real;
    dx, dy: real;
    R: integer;
    exist: boolean;
    stopped: boolean;
    col: TColor;
    ID: integer;
    procedure Draw;
    procedure Stop;
    destructor Destroy;
    function InLose(var Number: integer): boolean;
    procedure outFrom(b: pBall);
    function CollisedWith: pBall;
  end;
  TCue = class(TObject)
    visible: boolean;
    ToBall: pBall;
    angle: real;
    energy: real;
    procedure Draw;
    procedure Hit;
  end;
  TBilliardTable = class(TObject)
    Width, Height: integer;
    Left, Right, Top, Bottom: integer;
    Ball: TList;
    Lose: TList;
    Cue: TCue;
    procedure Draw;
  end;

  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Image1: TImage;
    procedure StopAll;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    procedure WOM_Open(var Mess: TMessage); message MM_WOM_OPEN;
    procedure WOM_Done(var Mess: TMessage); message MM_WOM_DONE;
  public
    { Public declarations }
  end;

var
  ballSize: integer = 10;
  loseSize: integer;// = ballSize + 5;
  MaxEnergy: integer = 20;
  CueLength: integer = 200;
  mu: real = 0.97;
  Step: real = 0.03;
  PyramidHeight: integer;
  MovementLimit: real;

  Form1: TForm1;
  BilliardTable: TBilliardTable;
  ShowID: boolean = False;
  InMotion: integer = 0;
  InLoses: integer = 0;
  balls: integer = 0;
  loses: integer = 0;
  tick: longint = 0;
  CompMove: integer = 0;
  CompAngle: real;
  Player: integer = 0; {0/1}
  PlayerN: array[0..1] of TPlayer;
  MovedLater: boolean = False;
  MustBeHitted: boolean = False;
  ShowLine: boolean = False;
  ballsIn: integer = 0;
  BallsInMove: boolean = False;
  dw, dh: integer;

  GameStatus: TGameStatus = gsGame;

  pcm: tWAVEFORMATEX;
  open_status: MMRESULT;
  WaveOut: HWaveOut;
  hOutput: integer;

implementation

{$R *.DFM}

procedure TBilliardTable.Draw;
var
  i: integer;
  b: pBall;
  lz: pLose;
  WhoIsIt: string;
begin
  case GameStatus of
    gsGame:
      with Form1.Image1 do
      begin
        Canvas.Brush.Color := clBlack;
        Canvas.Pen.Color := clBlack;
        Canvas.Rectangle(0,0,Width, Height);
        Canvas.Brush.Color := $336699;
        Canvas.Pen.Color := clYellow;
        Canvas.Rectangle(BilliardTable.Left - LoseSize, BilliardTable.Top - LoseSize,
                         BilliardTable.Right + LoseSize, BilliardTable.Bottom + LoseSize);
        Canvas.Brush.Color := clGreen;
        Canvas.Rectangle(BilliardTable.Left, BilliardTable.Top, BilliardTable.Right, BilliardTable.Bottom);
        Canvas.Pen.Color := clYellow;
        Canvas.Pen.Color := clBlack;
        Canvas.Ellipse(BilliardTable.Left + (3 * BilliardTable.Width div 4)-2,
                       BilliardTable.Top + (BilliardTable.Height div 2)-2,
                       BilliardTable.Left + (3 * BilliardTable.Width div 4)+2,
                       BilliardTable.Top + (BilliardTable.Height div 2)+2);
        Canvas.Brush.Color := $336699;
        Canvas.Font.Color := clYellow;
        Canvas.Font.Style := [];
        if Player = 0
          then WhoIsIt := '';
        if Player = 1
          then WhoIsIt := '';

        Canvas.TextOut(BilliardTable.Left+30, dh + 1,
          ': '+WhoIsIt+'');
        Canvas.TextOut(BilliardTable.Left+30, BilliardTable.Bottom,
          ' :'+IntToStr(InLoses));
        if Player = 0 then Canvas.Font.Style := [fsBold];
        Canvas.TextOut(BilliardTable.Right-150, BilliardTable.Bottom,
          ':'+IntToStr(PlayerN[0].balls));
        Canvas.Font.Style := [];
        if Player = 1 then Canvas.Font.Style := [fsBold];
        Canvas.TextOut(BilliardTable.Right-150, dh + 1,
          ':'+IntToStr(PlayerN[1].balls));

        Canvas.Brush.Color := clBlack;
        Canvas.Font.Color := clYellow;
        Canvas.Font.Style := [fsBold];
        Canvas.TextOut(10, 4, author);

        Canvas.Font.Style := [];

        for i := 0 to Lose.Count-1 do
        begin
          lz := Lose.Items[i];
          lz.Draw;
        end;
        for i := 0 to Ball.Count-1 do
        begin
          b := Ball.Items[i];
          if b.exist then b.Draw;
        end;
        if Cue.visible then Cue.Draw;
      end;
    gsGameOver:
      begin
      end;
  end;// case;
end;

destructor TBall.Destroy;
begin
end;

procedure TLose.Draw;
begin
  with Form1.Image1.Canvas do
  begin
    Brush.Color := clBlack;
    Pen.Color := clYellow;
    Ellipse(Trunc(x-r), Trunc(y-r),
            Trunc(x+r), Trunc(y+r));
    Font.Color := clWhite;
    TextOut(x-4,y-8, IntToStr(ballsInside));
  end;
end;

procedure TBall.Draw;
begin
  with Form1.Image1.Canvas do
  begin
    Brush.Color := col;
    Pen.Color := col;//clBlack;
    Ellipse(Trunc(x-r), Trunc(y-r),
            Trunc(x+r), Trunc(y+r));
    Brush.Color := clWhite;
    Pen.Color := clWhite;
    Ellipse(Trunc(x-r*sqrt(2)/2*0.5-2), Trunc(y-r*sqrt(2)/2*0.5-2),
            Trunc(x-r*sqrt(2)/2*0.5+2), Trunc(y-r*sqrt(2)/2*0.5+2));
    Brush.Color := col;
    Font.Color := clWhite - col;
    if ShowID then
    begin
      TextOut(Trunc(x-4), Trunc(y-8), IntToStr(ID));
    end;
    Refresh;
  end;
end;

procedure TCue.Draw;
var
  x1, y1, x2, y2, x3, y3: integer;
begin
  with Form1.Image1.Canvas do
  begin
    Brush.Color := clYellow;
    Pen.Color := clYellow;
    Pen.Width := 4;
    x1 := Trunc(ToBall.x+cos(Angle)*(ToBall.R+energy));
    y1 := Trunc(ToBall.y+sin(Angle)*(ToBall.R+energy));
    x2 := Trunc(ToBall.x+cos(Angle)*(ToBall.R+CueLength+energy));
    y2 := Trunc(ToBall.y+sin(Angle)*(ToBall.R+CueLength+energy));
    x3 := Trunc(ToBall.x-cos(Angle)*1000);
    y3 := Trunc(ToBall.y-sin(Angle)*1000);
    MoveTo(x1, y1);
    LineTo(x2, y2);
    Pen.Width := 1;
    Brush.Color := clWhite;
    Pen.Color := clWhite;
    Ellipse(x1-2,y1-2,x1+2,y1+2);
    if ShowLine then
    begin
      Pen.Style := psDash;
      MoveTo(x1, y1);
      LineTo(x3, y3);
      Pen.Style := psSolid;
    end;
  end;
end;

procedure TBall.Stop;
begin
  dx := 0;
  dy := 0;
  stopped := true;
end;

function TBall.InLose(var Number: integer): boolean;
var
  i: integer;
  lz: pLose;
  inLz: boolean;
begin
  Result := False;

  if not exist then exit;
  for i := 0 to BilliardTable.Lose.Count-1 do
  begin
    lz := BilliardTable.Lose.Items[i];
    inLz := sqrt(sqr(x-lz.x)+sqr(y-lz.y)) <= lz.R;
    if inLz then
    begin
      Number := i;
      Result := True;
      inc(InLoses);
      Exit;
    end;
  end;
end;

function TBall.CollisedWith: pBall;
var
  j: integer;
  bb: pBall;
  d, delta, ddx, ddy: real;
begin
  Result := nil;
  if not exist then exit;
  for j := 0 to BilliardTable.Ball.Count-1 do
  begin
    bb := BilliardTable.Ball.Items[j];
    if not bb.exist then continue;
    if bb.ID = ID then continue;
    d := sqrt(sqr(x-bb.x)+sqr(y-bb.y));
    if (d <= R + bb.R) then
    begin
      //  ,    
      //    
      delta := (R+bb.R - d)/2 + 1;
      ddx := (bb.x-x)/d;
      ddy := (bb.y-y)/d;
      x := x - ddx*delta;
      y := y - ddy*delta;
      bb.x := bb.x + ddx*delta;
      bb.y := bb.y + ddy*delta;
      Result := bb;
      exit;
    end;
  end;
end;

procedure TBall.outFrom(b: pBall);
var
  AB,
  aa, bb,
  V1, V2,
  aPrXx, aPrXy,
  aPrYx, aPrYy,
  aPrX, aPrY,
  bPrXx, bPrXy,
  bPrYx, bPrYy,
  bPrX, bPrY,
  alfaA, betaA, gammaA,
  alfaB, betaB, gammaB: Extended;
begin
  if b = nil then exit;


  AB := sqrt(sqr(x-b.x)+sqr(y-b.y));
  V1 := sqrt(dx*dx+dy*dy);
  V2 := sqrt(b.dx*b.dx+b.dy*b.dy);

  aPrXx := 0;
  aPrXy := 0;
  bPrXx := 0;
  bPrXy := 0;
////////-ball #1-
  if V1>0 then begin
    if (b.y-y)>0
      then alfaA := arccos((b.x-x)/AB)
      else alfaA := -arccos((b.x-x)/AB);
    if dy>0
      then gammaA := arccos(dx/V1)
      else gammaA := -arccos(dx/V1);
    betaA := gammaA-alfaA;

    aPrX := V1*cos(betaA);
    aPrY := V1*sin(betaA);
    aPrXx := aPrX*cos(alfaA);
    aPrXy := aPrX*sin(alfaA);
    aPrYx := aPrY*sin(alfaA);
    aPrYy := aPrY*cos(alfaA);
  end;

//////////////-ball #2-
  if V2>0 then begin
    if (y-b.y)>0
      then alfaB := arccos((x-b.x)/AB)         //=alfaA+pi
      else alfaB := -arccos((x-b.x)/AB);
    if b.dy>0
      then gammaB := arccos(b.dx/V2)
      else gammaB := -arccos(b.dx/V2);
    betaB := gammaB-alfaB;

    bPrX := V2*cos(betaB);
    bPrY := V2*sin(betaB);
    bPrXx := bPrX*cos(alfaB);
    bPrXy := bPrX*sin(alfaB);
    bPrYx := bPrY*sin(alfaB);
    bPrYy := bPrY*cos(alfaB);
  end;

  dx := ((dx - 2*aPrXx) + bPrXx)*mu;            // = mu*(bPrXx - aPrXx)
  dy := ((dy - 2*aPrXy) + bPrXy)*mu;            // = mu*(bPrXy - aPrXy)
  b.dx := ((b.dx - 2*bPrXx) + aPrXx)*mu;        // = mu*(aPrXx - bPrXx)
  b.dy := ((b.dy - 2*bPrXy) + aPrXy)*mu;        // = mu*(aPrXy - bPrXy)
end;

function GetAngToXY( b: pBall; hitX, hitY: real): real;
var
  dx, dy, d: real;
begin
  //   ,    
  dx := b.x - hitX;
  dy := b.y - hitY;
  d := sqrt(dx*dx+dy*dy);
  if (dy)>0
    then Result := arccos(dx/d)
    else Result := -arccos(dx/d);
end;

function CalculateAngle: real;
var
  i, j: integer;
  ToLz, lz: pLose;
  nearestBall, Bl, b: pBall;
  hitX, hitY: real;
  minAng, a2Lz, minD,
  dx, dy, a, minDist, d: real;
begin
  minDist := 1.7e+308;
  minD := minDist;
  with BilliardTable do
  begin
    // ,        
    for j := 0 to Lose.Count-1 do
      for i := 0 to Ball.Count-1 do
      begin
        lz := Lose.Items[j];
        b := Ball.Items[i];
        if not b.exist then continue;
        d := sqrt(sqr(b.x-lz.x)+sqr(b.y-lz.y));
        if d < minDist then
        begin
          minDist := d;
          ToLz := lz;
          Bl := b;
        end;
      end;
    if (Bl = nil) then exit;

    // :        
    //    :
    // ) ,     ( )
    //      
    // )   (..    )
    //        (   90 )

    //      
    dx := Bl.x - ToLz.x;
    dy := Bl.y - ToLz.y;
    d := sqrt(dx*dx+dy*dy);
    if (dy)>0
      then a2Lz := arccos(dx/d)
      else a2Lz := -arccos(dx/d);
    //   
    hitX := Bl.x + cos(a2Lz)*Bl.R;
    hitY := Bl.y + sin(a2Lz)*Bl.R;

    minAng := 1.7e+308;
    for i := 0 to Ball.Count-1 do
    begin
      b := Ball.Items[i];
      if (b.ID = Bl.ID) or (not b.exist)
        then continue;
      a := GetAngToXY(b, hitX, hitY);
      if abs(a2Lz-a) < minAng then
      begin
        minAng := abs(a2Lz-a);
        nearestBall := b;
        Result := a;
      end;
    end;
{
    //     
    for i := 0 to Ball.Count-1 do
    begin
      b := Ball.Items[i];
      if (b.ID = Bl.ID) or (not b.exist)
        then continue;
      d := sqrt(sqr(b.x-Bl.x)+sqr(b.y-Bl.y));
      if d < minD then
      begin
        minD := d;
        nearestBall := b;
      end;
    end;
    //      
    dx := Bl.x - ToLz.x;
    dy := Bl.y - ToLz.y;
    d := sqrt(dx*dx+dy*dy);
    if (dy)>0
      then a2Lz := arccos(dx/d)
      else a2Lz := -arccos(dx/d);
    //   
    hitX := Bl.x + cos(a2Lz)*Bl.R;
    hitY := Bl.y + sin(a2Lz)*Bl.R;

    //   ,    
    dx := nearestBall.x - hitX;
    dy := nearestBall.y - hitY;
    d := sqrt(dx*dx+dy*dy);
    if (dy)>0
      then a := arccos(dx/d)
      else a := -arccos(dx/d);
    Result := a;
}
    Cue.ToBall := nearestBall; //-> hitBall
  end;
end;

procedure ComputerMove;
begin
  with BilliardTable do
  begin
    Cue.visible := True;
    CompAngle := CalculateAngle;
    if CompAngle > Cue.angle
      then CompMove := 1
      else CompMove := -1;
  end;
end;

procedure InitSound;
begin
  pcm.wFormatTag := WAVE_FORMAT_PCM;
  pcm.nChannels := 1;
  pcm.nSamplesPerSec := 44100;
  pcm.nAvgBytesPerSec := 2*44100;
  pcm.nBlockAlign := 2;
  pcm.wBitsPerSample := 16;
  pcm.cbSize := 0;

  WaveOut := 0;
  open_status := waveOutOpen(@WaveOut, 0, @pcm, Form1.Handle,
    0, callback_Window);
end;

procedure TForm1.WOM_Open(var Mess: TMessage);
var
  hWaveOutHdr: PWaveHdr;
begin
  hOutput := Mess.WParam;
  hWaveOutHdr.lpData := 0;
  waveOutPrepareHeader(WaveOut, hWaveOutHdr, 0);
  waveOutWrite(WaveOut, hWaveOutHdr, 0);
end;

procedure TForm1.WOM_Done(var Mess: TMessage);
var
  lpwvhdr: WAVEHDR;
begin
//  lpwvhdr := Mess.WParam;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i, j: integer;
  b: pBall;
  luza: pLose;
  unique, inrect: boolean;
begin
  randomize;
  Player := 0;
  CompMove := 0;
  Timer1.Enabled := True;
  with Image1.Canvas do
  begin
    Brush.Color := clWhite;
    Pen.Color := clBlack;
    Rectangle(0, 0, Width, Height);
  end;
  BilliardTable.Ball.Clear;
  BilliardTable.Lose.Clear;
  balls := -1;

  new(b);
  inc(balls);
  b.x := BilliardTable.Width div 4 + BilliardTable.Left;
  b.y := BilliardTable.Height div 2 + BilliardTable.Top;
  b.R := ballSize;//Random(20)+10;
  b.col := clLtGray;//Random(clWhite);
  b.dx := Random*2-1;
  b.dy := Random*2-1;
  b.ID := 0;
  b.exist := True;
  BilliardTable.Ball.Add(b);
  PlayerN[0].balls := 0;
  PlayerN[1].balls := 0;

  GameStatus := gsGame;
  
  loses := -1;
  for j := 0 to 1 do
    for i := -1 to 1 do
    begin
      new(luza);
      inc(loses);
      luza.x := BilliardTable.Left + (BilliardTable.Width div 2)*(i+1);
      luza.y := BilliardTable.Top + (BilliardTable.Height div 2)*(j*2);
      luza.R := loseSize;
      if abs(i)=1 then
      begin
        luza.x := trunc(luza.x - i*luza.R*sqrt(2)/2);
        luza.y := trunc(luza.y -(j*2-1)*luza.R*sqrt(2)/2);
      end;
      luza.ballsInside := 0;
      BilliardTable.Lose.Add(luza);
    end;
  for j := 1 to PyramidHeight do
    for i := 1 to j do
    begin
      new(b);
      inc(balls);
      b.R := ballSize;          //Random(20)+10;
      b.col := clLtGray;        //Random(clWhite);//clLtGray;
      b.dx := Random*2-1;
      b.dy := Random*2-1;
      b.ID := balls;
      b.exist := True;

      if j mod 2 <> 0
        then b.y := -((j-1) div 2)*2*b.R+(i-1)*2*b.R + H div 2
        else b.y := -((j-1) div 2)*2*b.R+(i-1)*2*b.R - b.R + H div 2;
      b.y := b.y + dh;
      b.x := (j-1)*2*b.R + 3 * BilliardTable.Width div 4 + dw + LoseSize;
{
    repeat
      unique := True;
      b.x := Random(Image1.Width);
      b.y := Random(Image1.Height);
      inrect := (b.x > b.R) and (b.x<Image1.Width-b.R) and
                (b.y > b.R) and (b.y<Image1.Height-b.R);

      unique := unique and (b.CollisedWith = nil);
      unique := unique and inrect;
    until unique;
}
    BilliardTable.Ball.Add(b);
  end;
  inc(Balls);

  BilliardTable.Cue.ToBall := BilliardTable.Ball.Items[0];
  BilliardTable.Cue.angle := 180*Pi/180;
  BilliardTable.Cue.visible := False;
  StopAll;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  INI: TIniFile;
begin
  try
    INI := TIniFile.Create(ExtractFilePath(ParamStr(0))+'\settings.ini');
    ballSize := INI.ReadInteger('Phisics', 'ballSize', 10);
    loseSize := INI.ReadInteger('Phisics', 'PocketSize', ballSize + 5);
    MaxEnergy := INI.ReadInteger('Phisics', 'MaxEnergy', 20);
    CueLength := INI.ReadInteger('Phisics', 'CueLength', 200);
    PyramidHeight := INI.ReadInteger('Phisics', 'PyramidHeight', 5);
    mu := INI.ReadFloat('Phisics', 'Friction', 0.97);
    Step := INI.ReadFloat('Phisics', 'AngleStep', 0.03);
    MovementLimit := INI.ReadFloat('Phisics', 'MovementLimit', 0.01);
    Timer1.Interval := INI.ReadInteger('Phisics', 'TimeInterval', 20);
  finally
    INI.Free;
  end;

  Width := Screen.Width-4;
  Height := Screen.Height-4;
  Panel1.Width := ClientWidth;
  Panel1.Height := ClientHeight;
  Image1.Width := ClientWidth;
  Image1.Height := ClientHeight;
  dw := (Image1.Width - W) div 2;
  dh := (Image1.Height - H) div 2;

  BilliardTable := TBilliardTable.Create;
  BilliardTable.Ball := TList.Create;
  BilliardTable.Lose := TList.Create;
  BilliardTable.Cue := TCue.Create;
  with BilliardTable do
  begin
    Left := dw + loseSize;
    Top := dh + loseSize;
    Width := W - LoseSize*2;
    Height := H - LoseSize*2;
    Right := Left + Width;
    Bottom := Top + Height;
  end;
  Player := 0;
  Button1Click(Sender);
end;

procedure TCue.Hit;
begin
  ToBall.dx := -cos(Angle)*energy;
  ToBall.dy := -sin(Angle)*energy;
  ToBall.stopped := False;
  Visible := False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  cur, i, num: integer;
  b, b2: pBall;
  allstopped: boolean;
  lz: pLose;
  d: real;
  Mess: string;
begin
  with BilliardTable do
  begin
    inc(tick);
{
    while Cue.Angle > 6.28 do
      Cue.Angle := Cue.angle - 6.28;
    while Cue.Angle < 0 do
      Cue.Angle := Cue.angle + 6.28;
}
    if (CompMove <> 0) {and (Player = 1)} then
    begin
      Cue.Angle := Cue.angle + Step*CompMove;
      if abs(CompAngle-Cue.Angle) <= Step
      then begin
        CompMove := 0;
        Cue.Angle := CompAngle;
        MustBeHitted := True;
      end
    end;
    if Player = 0 then MustBeHitted := False;
    if MustBeHitted then
      if Cue.energy > MaxEnergy/2 then
      begin
        Cue.Hit;
        MustBeHitted := False;
      end;

    for i := 0 to Ball.Count-1 do
    begin
      b := Ball.Items[i];
      if not b.exist then continue;

      if b.InLose(num) then
      begin
        b.Stop;
        b.exist := False;
        dec(balls);
        inc(ballsIn);
        lz := BilliardTable.Lose.Items[num];
        inc(lz.ballsInside);
        inc(PlayerN[Player].balls);
        if Balls = 1 then
        begin
          GameStatus := gsGameOver;
          Timer1.Enabled := False;
          if PlayerN[0].balls > PlayerN[1].balls
            then Mess := 'You Win!'
            else if PlayerN[0].balls < PlayerN[1].balls
              then Mess := 'I''m a Winner!'
              else Mess := 'No Winner!!!';
          if MessageDlg(Mess+#10#13+'Repeat Game?',
            mtCustom, [mbYes, mbNo], 0)in [mrYes]
            then begin
              Button1Click(Sender);
              Timer1.Enabled := True;
            end;
        end;
        cur := Cue.ToBall.ID;
        repeat
          cur := (cur + 1) mod Ball.Count;
          b := Ball.Items[cur];
        until b.exist;
        Cue.ToBall := b;
      end;

      b.dx := b.dx*mu;
      b.dy := b.dy*mu;
      if (b.x+b.dx > BilliardTable.Right-b.R)
      or (b.x+b.dx < BilliardTable.Left+b.R)
        then b.dx := -b.dx * mu;
      b.x := b.x + b.dx;
      if (b.y+b.dy > BilliardTable.Bottom-b.R)
      or (b.y+b.dy < BilliardTable.Top+b.R)
        then b.dy := -b.dy * mu;
      b.y := b.y + b.dy;

      b2 := b.collisedWith;
      b.outFrom(b2);

      d := sqrt(sqr(b.dx)+sqr(b.dy));
      if d < MovementLimit then
      begin
        b.Stop;
      end;

    Cue.energy := Trunc(MaxEnergy/2*cos(tick/5)+MaxEnergy/2)+1;
    end;

    allstopped := True;
    for i := 0 to Ball.Count - 1 do
    begin
      b := Ball.Items[i];
      allstopped := (b.dx = 0) and (b.dy = 0) and allstopped;
    end;
    if allstopped and MovedLater then
    begin
      Cue.visible := True;
      if ballsIn = 0
        then Player := 1 - Player;
      if Player = 1 then ComputerMove;
      ballsIn := 0;
    end;
    MovedLater := not allstopped;
    BallsInMove := not allStopped;
    Draw;
  end;
end;

procedure TForm1.StopAll;
var
  i: integer;
  b: pBall;
begin
  with BilliardTable do
  begin
    for i := 0 to Ball.Count-1 do
    begin
      b := Ball.Items[i];
      b.dx := 0;
      b.dy := 0;
    end;
    Cue.Visible := True;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  cur: integer;
  b: pBall;
begin
  with BilliardTable do
  begin
    if Key = 27 then Application.Terminate;
    if BallsInMove then exit;
    if not Cue.Visible then exit;
    if Player = 1 then exit;//      !
    cur := Cue.ToBall.ID;
    if (Key = VK_DOWN)
      then Cue.Angle := Cue.angle - Step;
    if (Key = VK_UP)
      then Cue.Angle := Cue.angle + Step;
    if Key = VK_RIGHT then
    repeat
      cur := (cur + 1) mod Ball.Count;
      b := Ball.Items[cur];
    until b.exist;
    if Key = VK_LEFT then
    repeat
      cur := (cur - 1 + Ball.Count) mod Ball.Count;
      b := Ball.Items[cur];
    until b.exist;
    if Key = 32 then if Cue.Visible then Cue.Hit;
    if Key = 13 then ComputerMove;
//    if Key = 13 then StopAll;
    Cue.ToBall := Ball.Items[cur];
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if BallsInMove then exit;
  if Key in ['i', 'I'] then
  begin
    ShowID := not ShowID;
  end;
  if Key in ['s', 'S'] then ShowLine := not ShowLine;
  if Player = 1 then exit;//      !
  if Key in ['h', 'H'] then ComputerMove;// help me!
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  INI: TIniFile;
begin
  try
    INI := TIniFile.Create(ExtractFilePath(ParamStr(0))+'\settings.ini');
    INI.WriteInteger('Phisics', 'ballSize', ballSize);
    INI.WriteInteger('Phisics', 'PocketSize', loseSize);
    INI.WriteInteger('Phisics', 'MaxEnergy', MaxEnergy);
    INI.WriteInteger('Phisics', 'CueLength', CueLength);
    INI.WriteInteger('Phisics', 'PyramidHeight', PyramidHeight);
    INI.WriteFloat('Phisics', 'Friction', mu);
    INI.WriteFloat('Phisics', 'AngleStep', Step);
    INI.WriteFloat('Phisics', 'MovementLimit', MovementLimit);
    INI.WriteInteger('Phisics', 'TimeInterval', Timer1.Interval);
  finally
    INI.Free;
  end;
end;

end.

